#include <amxmodx>
#include <fun>
#include <hamsandwich>
#include <zombieplaguenightmare>

new g_bsIsFrozen;

#define GetBits(%0,%1)			( %0 & ( 1 << ( %1 & 31 ) ) )
#define SetBits(%0,%1)			( %0 |= ( 1 << ( %1 & 31 ) ) )
#define ClearBits(%0,%1)		( %0 &= ~( 1 << ( %1 & 31 ) ) )

public plugin_init()
{
	register_plugin("[ZPNM] Freeze system new", "0.0.2", "D i 5 7 i n c T, NiHiLaNTh")
	
	RegisterHam(Ham_Spawn, "player", "OnPlayerSpawn", 1)
	RegisterHam(Ham_Player_Duck, "player", "OnPlayerDuckOrJump")
	RegisterHam(Ham_Player_Jump, "player", "OnPlayerDuckOrJump")
}

public client_disconnect(id)
	ClearBits(g_bsIsFrozen, id)

public OnPlayerSpawn(id)
	ClearBits(g_bsIsFrozen, id)

public OnPlayerDuckOrJump(id)
{
	if (!GetBits(g_bsIsFrozen, id))
		return HAM_IGNORED;
	
	return HAM_SUPERCEDE;
}

public zpnm_user_frozen(id)
{
	SetBits(g_bsIsFrozen, id)
	
//	zpnm_reset_user_maxspeed(id)
	set_user_gravity(id, 1.0) // este setat velocity in prethink main, nu am ce sa ii fac
}

public zp_user_unfrozen(id)
{
	ClearBits(g_bsIsFrozen, id)
}
