#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <zombieplaguenightmare>

const PDATA_SAFE = 2
const OffsetLinuxWeapon = 4
const m_pPlayer = 41
const m_fInReload = 54
const m_fInSpecialReload = 55
const m_flTimeWeaponIdle = 48
const Float:fCooldown = 35.7

new Float:fLastReload[33]

new const SoundReloadM[][] =
{
	"zs/reload1.wav",
	"zs/reload2.wav",
	"zs/reload3.wav"
}

new const SoundReloadF[][] =
{
	"zs/reloadf1.wav",
	"zs/reloadf2.wav",
	"zs/reloadf3.wav"
}

public plugin_precache()
{
	new i;
	
	for (i = 0; i < sizeof SoundReloadM; i++)
		precache_sound(SoundReloadM[i])
	
	for (i = 0; i < sizeof SoundReloadF; i++)
		precache_sound(SoundReloadF[i])
}

public plugin_init()
{
	register_plugin("ZM Reload Voice", "0.0.1", "wbyokomo")
	
	RegisterHam(Ham_Weapon_Reload, "weapon_glock18", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_usp", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_deagle", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_p228", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_elite", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_fiveseven", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_m3", "FwdHamWeaponReloadSg", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_xm1014", "FwdHamWeaponReloadSg", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_mp5navy", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_mac10", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_tmp", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_p90", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_ump45", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_galil", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_famas", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_ak47", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_m4a1", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_sg552", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_aug", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_g3sg1", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_sg550", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_scout", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_awp", "FwdHamWeaponReload", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_m249", "FwdHamWeaponReload", 1)
}

public FwdHamWeaponReload(iWeapon)
{
	if(pev_valid(iWeapon) != PDATA_SAFE) return;
	
	if(get_pdata_int(iWeapon, m_fInReload, OffsetLinuxWeapon))
	{
		static iOwner; iOwner = get_pdata_cbase(iWeapon, m_pPlayer, OffsetLinuxWeapon)
		if(is_user_connected(iOwner)) DoReloadVox(iOwner);
	}
}

public FwdHamWeaponReloadSg(iWeapon)
{
	if(pev_valid(iWeapon) != PDATA_SAFE) return;
	if(get_pdata_int(iWeapon, m_fInSpecialReload, OffsetLinuxWeapon) != 1) return;
	if(get_pdata_float(iWeapon, m_flTimeWeaponIdle, OffsetLinuxWeapon) != 0.55) return;
	
	static iOwner; iOwner = get_pdata_cbase(iWeapon, m_pPlayer, OffsetLinuxWeapon)
	if(is_user_connected(iOwner)) DoReloadVox(iOwner);
}

DoReloadVox(id)
{
	static Float:fTime; fTime = get_gametime()
	if((fTime - fCooldown) > fLastReload[id])
	{
		fLastReload[id] = fTime
		
		new hclass = zpnm_get_user_human_class(id)
		
		if((hclass == 2 || hclass == 4) && !zp_get_user_survivor(id) && !zpnm_get_user_sniper(id))
			emit_sound(id, CHAN_VOICE, SoundReloadF[random(sizeof(SoundReloadF))], 1.0, ATTN_NORM, 0, PITCH_NORM);
		else
			emit_sound(id, CHAN_VOICE, SoundReloadM[random(sizeof(SoundReloadM))], 1.0, ATTN_NORM, 0, PITCH_NORM);
	}
}
